gtkmm: Gdk::Display Class Reference

gtkmm 3.4.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gdk::Display Class Reference

Gdk::Display object's purpose is two fold: To grab/ungrab keyboard focus and mouse pointer To manage and provide information about the Gdk::Screen(s) available for this Gdk::Display. More...

Inheritance diagram for Gdk::Display:
[legend]

List of all members.

## Public Member Functions
virtual | ~Display ()
GdkDisplay* | gobj ()
| Provides access to the underlying C GObject.
const GdkDisplay* | gobj () const
| Provides access to the underlying C GObject.
GdkDisplay* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ustring | get_name () const
| Gets the name of the display.
int | get_n_screens () const
| Gets the number of screen managed by the display.
Glib::RefPtr< Screen > | get_screen (int screen_num)
| Returns a screen object for one of the screens of the display.
Glib::RefPtr< const Screen > | get_screen (int screen_num) const
| Returns a screen object for one of the screens of the display.
Glib::RefPtr< Screen > | get_default_screen ()
| Get the default Gdk::Screen for display.
Glib::RefPtr< const Screen > | get_default_screen () const
| Get the default Gdk::Screen for display.
void | beep ()
| Emits a short beep on display.
void | sync ()
| Flushes any requests queued for the windowing system and waits until all requests have been handled.
void | close ()
| Closes the connection to the windowing system for the given display, and cleans up associated resources.
bool | is_closed () const
| Finds out if the display has been closed.
GdkEvent* | get_event ()
| Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary.
const GdkEvent* | get_event () const
| Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary.
GdkEvent* | peek_event ()
| Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue.
GdkEvent* | peek_event () const
| Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue.
void | put_event (GdkEvent* event)
| Appends a copy of the given event onto the front of the event queue for display.
bool | has_pending () const
| Returns whether the display has events that are waiting to be processed.
void | set_double_click_time (guint msec)
| Sets the double click time (two clicks within this time interval count as a double click and result in a Gdk::2BUTTON_PRESS event).
void | set_double_click_distance (guint distance)
| Sets the double click distance (two clicks within this distance count as a double click and result in a Gdk::2BUTTON_PRESS event).
GdkKeymap* | get_keymap ()
| Returns the Gdk::Keymap attached to display.
const GdkKeymap* | get_keymap () const
| Returns the Gdk::Keymap attached to display.
bool | set_selection_owner (const Glib::RefPtr< Window >& owner, Glib::ustring& selection, guint32 time_, bool send_event)
Glib::RefPtr< Window > | get_selection_owner (const Glib::ustring& selection)
void | selection_send_notify (const Glib::RefPtr< Window >& requestor, Glib::ustring& selection, Glib::ustring& target, Glib::ustring& property, guint32 time_)
| Send a response to SelectionRequest event.
void | flush ()
| Flushes any requests queued for the windowing system; this happens automatically when the main loop blocks waiting for new events, but if your application is drawing without returning control to the main loop, you may need to call this function explicitely.
bool | supports_cursor_alpha () const
| Returns `true` if cursors can use an 8bit alpha channel on display.
bool | supports_cursor_color () const
| Returns `true` if multicolored cursors are supported on display.
guint | get_default_cursor_size () const
| Returns the default size to use for cursors on display.
void | get_maximal_cursor_size (guint& width, guint& height)
| Gets the maximal size to use for cursors on display.
Glib::RefPtr< Window > | get_default_group ()
| Returns the default group leader window for all toplevel windows on display.
Glib::RefPtr< const Window > | get_default_group () const
| Returns the default group leader window for all toplevel windows on display.
bool | supports_selection_notification () const
| Returns whether Gdk::EventOwnerChange events will be sent when the owner of a selection changes.
bool | request_selection_notification (const Glib::ustring& selection)
| Request Gdk::EventOwnerChange events for ownership changes of the selection named by the given atom.
bool | supports_clipboard_persistence () const
| Returns whether the speicifed display supports clipboard persistance; i.e. if it's possible to store the clipboard data after an application has quit.
void | store_clipboard (const Glib::RefPtr< Gdk::Window >& clipboard_window, guint32 time_)
| Issues a request to the clipboard manager to store the clipboard data, saving all available targets.
void | store_clipboard (const Glib::RefPtr< Gdk::Window >& clipboard_window, guint32 time_, const std::vector< Glib::ustring >& targets)
bool | supports_shapes () const
| Returns `true` if gdk_window_shape_combine_mask() can be used to create shaped windows on display.
bool | supports_input_shapes () const
| Returns `true` if gdk_window_input_shape_combine_mask() can be used to modify the input shape of windows on display.
bool | supports_composite () const
| Returns `true` if Gdk::Window::set_composited() can be used to redirect drawing on the window using compositing.
void | notify_startup_complete (const Glib::ustring& startup_id)
| Indicates to the GUI environment that the application has finished loading, using a given identifier.
Glib::RefPtr< DeviceManager > | get_device_manager ()
| Returns the Gdk::DeviceManager associated to display.
Glib::RefPtr< const DeviceManager > | get_device_manager () const
| Returns the Gdk::DeviceManager associated to display.
Glib::RefPtr< AppLaunchContext > | get_app_launch_context ()
| Returns a Gdk::AppLaunchContext suitable for launching applications on the given display.
Glib::RefPtr< const AppLaunchContext > | get_app_launch_context () const
| Returns a Gdk::AppLaunchContext suitable for launching applications on the given display.
Glib::SignalProxy1< void, bool > | signal_closed ()
Glib::SignalProxy0< void > | signal_opened ()
## Static Public Member Functions
static Glib::RefPtr< Display > | open (const Glib::ustring& display_name)
| Opens a display.
static Glib::RefPtr< Display > | get_default ()
| Gets the default Gdk::Display.
static Glib::RefPtr< Display > | open_default_libgtk_only ()
| Opens the default display specified by command line arguments or environment variables, sets it as the default display, and returns it.
## Protected Member Functions
| Display ()
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::Display > | wrap (GdkDisplay* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Gdk::Display object's purpose is two fold: To grab/ungrab keyboard focus and mouse pointer To manage and provide information about the Gdk::Screen(s) available for this Gdk::Display.

Gdk::Display objects are the GDK representation of the X Display which can be described as a workstation consisting of a keyboard a pointing device (such as a mouse) and one or more screens. It is used to open and keep track of various Gdk::Screen objects currently instantiated by the application. It is also used to grab and release the keyboard and the mouse pointer.

## Constructor & Destructor Documentation

virtual Gdk::Display::~Display | ( |  | ) | `[virtual]`

Gdk::Display::Display | ( |  | ) | `[protected]`

## Member Function Documentation

void Gdk::Display::beep | ( |  | ) |

Emits a short beep on display.

Since gtkmm 2.2:

void Gdk::Display::close | ( |  | ) |

Closes the connection to the windowing system for the given display, and cleans up associated resources.

Since gtkmm 2.2:

void Gdk::Display::flush | ( |  | ) |

Flushes any requests queued for the windowing system; this happens automatically when the main loop blocks waiting for new events, but if your application is drawing without returning control to the main loop, you may need to call this function explicitely.

A common case where this function needs to be called is when an application is executing drawing commands from a thread other than the thread where the main loop is running.

This is most useful for X11. On windowing systems where requests are handled synchronously, this function will do nothing.

Since gtkmm 2.4:

Glib::RefPtr<AppLaunchContext> Gdk::Display::get_app_launch_context | ( |  | ) |

Returns a Gdk::AppLaunchContext suitable for launching applications on the given display.

Since gtkmm 3.0:

Returns:
  A new Gdk::AppLaunchContext for display. Free with Glib::object_unref() when done.

Glib::RefPtr<const AppLaunchContext> Gdk::Display::get_app_launch_context | ( |  | ) | const

Returns a Gdk::AppLaunchContext suitable for launching applications on the given display.

Since gtkmm 3.0:

Returns:
  A new Gdk::AppLaunchContext for display. Free with Glib::object_unref() when done.

static Glib::RefPtr<Display> Gdk::Display::get_default | ( |  | ) | `[static]`

Gets the default Gdk::Display.

This is a convenience function for `gdk_display_manager_get_default_display (Gdk::DisplayManager::get())`.

Since gtkmm 2.2:

Returns:
  A Gdk::Display, or `0` if there is no default display.

guint Gdk::Display::get_default_cursor_size | ( |  | ) | const

Returns the default size to use for cursors on display.

Since gtkmm 2.4:

Returns:
  The default cursor size.

Glib::RefPtr<Window> Gdk::Display::get_default_group | ( |  | ) |

Returns the default group leader window for all toplevel windows on display.

This window is implicitly created by GDK. See Gdk::Window::set_group().

Since gtkmm 2.4:

Returns:
  The default group leader window for display.

Glib::RefPtr<const Window> Gdk::Display::get_default_group | ( |  | ) | const

Returns the default group leader window for all toplevel windows on display.

This window is implicitly created by GDK. See Gdk::Window::set_group().

Since gtkmm 2.4:

Returns:
  The default group leader window for display.

Glib::RefPtr<Screen> Gdk::Display::get_default_screen | ( |  | ) |

Get the default Gdk::Screen for display.

Since gtkmm 2.2:

Returns:
  The default Gdk::Screen object for display.

Glib::RefPtr<const Screen> Gdk::Display::get_default_screen | ( |  | ) | const

Get the default Gdk::Screen for display.

Since gtkmm 2.2:

Returns:
  The default Gdk::Screen object for display.

Glib::RefPtr<DeviceManager> Gdk::Display::get_device_manager | ( |  | ) |

Returns the Gdk::DeviceManager associated to display.

Since gtkmm 3.0:

Returns:
  A Gdk::DeviceManager, or `0`. This memory is owned by GDK and must not be freed or unreferenced.

Glib::RefPtr<const DeviceManager> Gdk::Display::get_device_manager | ( |  | ) | const

Returns the Gdk::DeviceManager associated to display.

Since gtkmm 3.0:

Returns:
  A Gdk::DeviceManager, or `0`. This memory is owned by GDK and must not be freed or unreferenced.

GdkEvent* Gdk::Display::get_event | ( |  | ) |

Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary.

Since gtkmm 2.2:

Returns:
  The next Gdk::Event to be processed, or `0` if no events are pending. The returned Gdk::Event should be freed with Gdk::Event::free().

const GdkEvent* Gdk::Display::get_event | ( |  | ) | const

Gets the next Gdk::Event to be processed for display, fetching events from the windowing system if necessary.

Since gtkmm 2.2:

Returns:
  The next Gdk::Event to be processed, or `0` if no events are pending. The returned Gdk::Event should be freed with Gdk::Event::free().

GdkKeymap* Gdk::Display::get_keymap | ( |  | ) |

Returns the Gdk::Keymap attached to display.

Since gtkmm 2.2:

Returns:
  The Gdk::Keymap attached to display.

const GdkKeymap* Gdk::Display::get_keymap | ( |  | ) | const

Returns the Gdk::Keymap attached to display.

Since gtkmm 2.2:

Returns:
  The Gdk::Keymap attached to display.

void Gdk::Display::get_maximal_cursor_size | ( | guint & | width,
|  | guint & | height
| ) |  |

Gets the maximal size to use for cursors on display.

Since gtkmm 2.4:

Parameters:

  width | The return location for the maximal cursor width.
  height | The return location for the maximal cursor height.

int Gdk::Display::get_n_screens | ( |  | ) | const

Gets the number of screen managed by the display.

Since gtkmm 2.2:

Returns:
  Number of screens.

Glib::ustring Gdk::Display::get_name | ( |  | ) | const

Gets the name of the display.

Since gtkmm 2.2:

Returns:
  A string representing the display name. This string is owned by GDK and should not be modified or freed.

Glib::RefPtr<Screen> Gdk::Display::get_screen | ( | int | screen_num | ) |

Returns a screen object for one of the screens of the display.

Since gtkmm 2.2:

Parameters:

  screen_num | The screen number.

Returns:
  The Gdk::Screen object.

Glib::RefPtr<const Screen> Gdk::Display::get_screen | ( | int | screen_num | ) | const

Returns a screen object for one of the screens of the display.

Since gtkmm 2.2:

Parameters:

  screen_num | The screen number.

Returns:
  The Gdk::Screen object.

Glib::RefPtr<Window> Gdk::Display::get_selection_owner | ( | const Glib::ustring & | selection | ) |

GdkDisplay* Gdk::Display::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GdkDisplay* Gdk::Display::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GdkDisplay* Gdk::Display::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gdk::Display::has_pending | ( |  | ) | const

Returns whether the display has events that are waiting to be processed.

Since gtkmm 3.0:

Returns:
  `true` if there are events ready to be processed.

bool Gdk::Display::is_closed | ( |  | ) | const

Finds out if the display has been closed.

Since gtkmm 2.22:

Returns:
  `true` if the display is closed.

void Gdk::Display::notify_startup_complete | ( | const Glib::ustring & | startup_id | ) |

Indicates to the GUI environment that the application has finished loading, using a given identifier.

GTK+ will call this function automatically for Gtk::Window with custom startup-notification identifier unless gtk_window_set_auto_startup_notification() is called to disable that feature.

Since gtkmm 3.0:

Parameters:

  startup_id | A startup-notification identifier, for which notification process should be completed.

static Glib::RefPtr<Display> Gdk::Display::open | ( | const Glib::ustring & | display_name | ) | `[static]`

Opens a display.

Since gtkmm 2.2:

Parameters:

  display_name | The name of the display to open.

Returns:
  A Gdk::Display, or `0` if the display could not be opened.

static Glib::RefPtr<Display> Gdk::Display::open_default_libgtk_only | ( |  | ) | `[static]`

Opens the default display specified by command line arguments or environment variables, sets it as the default display, and returns it.

gdk_parse_args must have been called first. If the default display has previously been set, simply returns that. An internal function that should not be used by applications.

Returns:
  The default display, if it could be opened, otherwise `0`.

GdkEvent* Gdk::Display::peek_event | ( |  | ) |

Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue.

(Note that this function will not get more events from the windowing system. It only checks the events that have already been moved to the GDK event queue.)

Since gtkmm 2.2:

Returns:
  A copy of the first Gdk::Event on the event queue, or `0` if no events are in the queue. The returned Gdk::Event should be freed with Gdk::Event::free().

GdkEvent* Gdk::Display::peek_event | ( |  | ) | const

Gets a copy of the first Gdk::Event in the display's event queue, without removing the event from the queue.

(Note that this function will not get more events from the windowing system. It only checks the events that have already been moved to the GDK event queue.)

Since gtkmm 2.2:

Returns:
  A copy of the first Gdk::Event on the event queue, or `0` if no events are in the queue. The returned Gdk::Event should be freed with Gdk::Event::free().

void Gdk::Display::put_event | ( | GdkEvent * | event | ) |

Appends a copy of the given event onto the front of the event queue for display.

Since gtkmm 2.2:

Parameters:

  event | A Gdk::Event.

bool Gdk::Display::request_selection_notification | ( | const Glib::ustring & | selection | ) |

Request Gdk::EventOwnerChange events for ownership changes of the selection named by the given atom.

Since gtkmm 2.6:

Parameters:

  selection | The Gdk::Atom naming the selection for which ownership change notification is requested.

Returns:
  Whether Gdk::EventOwnerChange events will be sent.

void Gdk::Display::selection_send_notify | ( | const Glib::RefPtr< Window >& | requestor,
|  | Glib::ustring & | selection,
|  | Glib::ustring & | target,
|  | Glib::ustring & | property,
|  | guint32 | time_
| ) |  |

Send a response to SelectionRequest event.

Since gtkmm 2.2:

Parameters:

  requestor | Window to which to deliver response.
  selection | Selection that was requested.
  target | Target that was selected.
  property | Property in which the selection owner stored the data, or "None" to indicate that the request was rejected.
  time_ | Timestamp.

void Gdk::Display::set_double_click_distance | ( | guint | distance | ) |

Sets the double click distance (two clicks within this distance count as a double click and result in a Gdk::2BUTTON_PRESS event).

See also set_double_click_time(). Applications should not set this, it is a global user-configured setting.

Since gtkmm 2.4:

Deprecated:
  No replacement method. Applications should not set this.

Parameters:

  distance | Distance in pixels.

void Gdk::Display::set_double_click_time | ( | guint | msec | ) |

Sets the double click time (two clicks within this time interval count as a double click and result in a Gdk::2BUTTON_PRESS event).

Applications should not set this, it is a global user-configured setting.

Since gtkmm 2.2:

Deprecated:
  No replacement method. Applications should not set this.

Parameters:

  msec | Double click time in milliseconds (thousandths of a second).

bool Gdk::Display::set_selection_owner | ( | const Glib::RefPtr< Window >& | owner,
|  | Glib::ustring & | selection,
|  | guint32 | time_,
|  | bool | send_event
| ) |  |

Glib::SignalProxy1< void,bool > Gdk::Display::signal_closed | ( |  | ) |

Slot Prototype:
  `void on_my_closed(bool is_error)`

The signal_closed() signal is emitted when the connection to the windowing system for display is closed.

Since gtkmm 2.2:

Parameters:

  is_error | `true` if the display was closed due to an error.

Glib::SignalProxy0< void > Gdk::Display::signal_opened | ( |  | ) |

Slot Prototype:
  `void on_my_opened()`

The signal_opened() signal is emitted when the connection to the windowing system for display is opened.

void Gdk::Display::store_clipboard | ( | const Glib::RefPtr< Gdk::Window >& | clipboard_window,
|  | guint32 | time_
| ) |  |

Issues a request to the clipboard manager to store the clipboard data, saving all available targets.

On X11, this is a special program that works according to the freedesktop clipboard specification, available at http://www.freedesktop.org/Standards/clipboard-manager-spec.

Since gtkmm 2.6:

Parameters:

  clipboard_window | A Gdk::Window belonging to the clipboard owner.
  time_ | A timestamp.

void Gdk::Display::store_clipboard | ( | const Glib::RefPtr< Gdk::Window >& | clipboard_window,
|  | guint32 | time_,
|  | const std::vector< Glib::ustring > & | targets
| ) |  |

bool Gdk::Display::supports_clipboard_persistence | ( |  | ) | const

Returns whether the speicifed display supports clipboard persistance; i.e. if it's possible to store the clipboard data after an application has quit.

On X11 this checks if a clipboard daemon is running.

Since gtkmm 2.6:

Returns:
  `true` if the display supports clipboard persistance.

bool Gdk::Display::supports_composite | ( |  | ) | const

Returns `true` if Gdk::Window::set_composited() can be used to redirect drawing on the window using compositing.

Currently this only works on X11 with XComposite and XDamage extensions available.

Since gtkmm 2.12:

Returns:
  `true` if windows may be composited.

bool Gdk::Display::supports_cursor_alpha | ( |  | ) | const

Returns `true` if cursors can use an 8bit alpha channel on display.

Otherwise, cursors are restricted to bilevel alpha (i.e. a mask).

Since gtkmm 2.4:

Returns:
  Whether cursors can have alpha channels.

bool Gdk::Display::supports_cursor_color | ( |  | ) | const

Returns `true` if multicolored cursors are supported on display.

Otherwise, cursors have only a forground and a background color.

Since gtkmm 2.4:

Returns:
  Whether cursors can have multiple colors.

bool Gdk::Display::supports_input_shapes | ( |  | ) | const

Returns `true` if gdk_window_input_shape_combine_mask() can be used to modify the input shape of windows on display.

Since gtkmm 2.10:

Returns:
  `true` if windows with modified input shape are supported.

bool Gdk::Display::supports_selection_notification | ( |  | ) | const

Returns whether Gdk::EventOwnerChange events will be sent when the owner of a selection changes.

Since gtkmm 2.6:

Returns:
  Whether Gdk::EventOwnerChange events will be sent.

bool Gdk::Display::supports_shapes | ( |  | ) | const

Returns `true` if gdk_window_shape_combine_mask() can be used to create shaped windows on display.

Since gtkmm 2.10:

Returns:
  `true` if shaped windows are supported.

void Gdk::Display::sync | ( |  | ) |

Flushes any requests queued for the windowing system and waits until all requests have been handled.

This is often used for making sure that the display is synchronized with the current state of the program. Calling sync() before gdk_error_trap_pop() makes sure that any errors generated from earlier requests are handled before the error trap is removed.

This is most useful for X11. On windowing systems where requests are handled synchronously, this function will do nothing.

Since gtkmm 2.2:

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Display > wrap | ( | GdkDisplay * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/display.h